/******************************************************************
 *
 *  EE-164 example code
 *  This example illustrates combination of EPROM booting, EPROM
 *  overlays and code execution directly from ROM.
 *
 *  ANALOG DEVICES INC. (bk) 2002
 *
 ******************************************************************/


#include <def2191.h>


/********************************************************************/
.section / code IVreset;
_reset:	
	
	iopg = External_Memory_Interface_Page;
	ar = 0x086D;
	io(BMSCTL) = ar;
	io(MS0CTL) = ar;
	ar = 0x0070;
	io(EMICTL) = ar;
	
	iopg = External_Access_Bridge_Page;
	ar = 0x000F;
	io(E_STAT) = ar;
	
	nop; nop; nop; nop;
	nop; nop; nop; nop;
	
	lcall _sys_init;	
		
	do _algo until forever;
		call _algorithm;	
		nop;
_algo:	nop;

	idle;

	
/********************************************************************/		
.section / code romcode;
_sys_init:

	l0 = 0;		
	l1 = 0;
	l2 = 0;
	l3 = 0;
	l4 = 0;		
	l5 = 0;
	l6 = 0;
	l7 = 0;
	
	dmpg1 = 0;
	iopg = 0;
	
	rts;

/********************************************************************/		

.section / data data1;
.var result_add = 0;
.var result_sub = 0;
.var result_mul = 0;
.var result_div = 0;

.section / code program;
_algorithm:

	ena mm;
	ax0 = 10;
	ay1 = 2;
	
	call _func_add;
	dm(result_add) = ar;

	call _func_sub;
	dm(result_sub) = ar;
	
	call _func_mul;
	dm(result_mul) = ar;
	
	call _func_div;
	dm(result_div) = ar;
		
	nop;
	nop;  

	rts;	
	

/********************************************************************/		
/*  OVERLAYS (must be global)                                       */

.section / code code_overlay1;

.global _func_add;	
_func_add:
			ar = ax0 + ay1;
			rts;

/********************************************************************/		
.section / code code_overlay2;

.global _func_sub;			
_func_sub:
			ar = ax0 - ay1;
			rts;			

/********************************************************************/		
.section / code code_overlay3;

.global _func_mul;						
_func_mul:
			rts (db);
				mr = ax0 * ay1 (ss);
				ar = mr0;			
			
						
/********************************************************************/		
.section / code code_overlay4;

.global _func_div;						
_func_div:
			// divide ax0 by ay1
			// integer division requires left shift 
			
			sr = lshift ax0 by 1 (lo);
			
			// unsigned division core
			// ay0 = af:ay0 / ay1
			
			af = pass 0, ay0 = sr0;
			astat = 0;			
			ar = ay1;
			
			divq ar; divq ar; divq ar; divq ar;
			divq ar; divq ar; divq ar; divq ar;
			divq ar; divq ar; divq ar; divq ar;
			divq ar; divq ar; divq ar; 
						
			rts (db);			
				divq ar;
				ar = ay0;


	
	
